  NN = 7:REM MAX TIMERS

  DIM D(NN):REM CURRENT DELTAS
  DIM T(NN):REM SET TIMERS
  DIM E(NN):REM EVENTS

  DIM X(NN)

  T(1) = 60:REM ONE SECOND  (1.000    S)
  T(2) = 30:REM 1/2 SECOND  ( .500    S) [      30/60TH=0.5   ]
  T(3) = 15:REM 1/4 SECOND  ( .250    S) [      15/60TH=0.25  ]
  T(4) = 7 :REM 1/8 SECOND  ( .125    S) [APPROX 7/60TH=0.1166]
  T(5) = 4 :REM 1/16 SECOND ( .0625   S) [APPROX 3/60TH=0.0500]
  T(6) = 2 :REM 1/32 SECOND ( .03125  S) [APPROX 2/60TH=0.0333]
  T(7) = 0 :REM 1/64 SECOND ( .015625 S) [APPROX 1/60TH=0.0166]

RESTART:
  FOR I = 1 TO NN
    E(I) = TI:REM SET EVENT-INDEX TO CURRENT JIFFIES COUNTER TI
    X(I) = 1:REM SET WHICH COLUMN SAMPLE OUTPUT STARTS ON
  NEXT I

  RESTORE
  PSGINIT
  SCREEN 1:REM 80X30
  CW=80:REM COLUMN WIDTH
  CLS
  LOCATE 19,1:PRINT "PRESS ESC TO EXIT";

MAINLOOP:

  LOCATE 2,2:PRINT TIME$;" ";TI;" ";FRE(0);

  FOR I = 1 TO NN
    D(I) = TI-E(I):REM COMPUTE CURRENT TIMER DELTAS FOR EACH EVENT
  NEXT I

  ZZ=0:REM ZZ USED AS CHECK ON IF WE'VE PASSED 80 COLUMNS
  IF D(1) > T(1) THEN GOSUB EVENTo1
  IF D(2) > T(2) THEN GOSUB EVENTo2
  IF D(3) > T(3) THEN GOSUB EVENTo3
  IF D(4) > T(4) THEN GOSUB EVENTo4
  IF D(5) > T(5) THEN GOSUB EVENTo5
  IF D(6) > T(6) THEN GOSUB EVENTo6
  IF D(7) > T(7) THEN GOSUB EVENTo7
  IF ZZ=1 GOTO RESTART

  GOTO MAINLOOP

EVENTo1:REM ONE SECOND STUFF
  REM *** DO STUFF ********
  LOCATE 5,X(1)
  PRINT "1";
  X(1) = X(1) + 1
  IF X(1) > CW THEN ZZ=1
  REM *********************

  E(1)=TI:REM IMPORTANT, DO NOT REMOVE
  RETURN

EVENTo2:REM HALF SECOND STUFF
  REM *** DO STUFF ********
  LOCATE 6,X(2)
  PRINT "2";
  X(2) = X(2) + 1
  IF X(2) > CW THEN ZZ=1
  REM ********************* 

  E(2)=TI:REM IMPORTANT, DO NOT REMOVE
  RETURN

EVENTo3:REM QUARTER SECOND STUFF
  REM *** DO STUFF ********
  LOCATE 7,X(3)
  PRINT "3";
  X(3) = X(3) + 1
  IF X(3) > CW THEN ZZ=1
  REM ********************* 

  E(3)=TI:REM IMPORTANT, DO NOT REMOVE
  RETURN

EVENTo4:REM 1/8 SECOND STUFF
  REM *** DO STUFF ********
  LOCATE 8,X(4)
  PRINT "4";
  X(4) = X(4) + 1
  IF X(4) > CW THEN ZZ=1

  REM EXAMPLE: GET AND PLAY NEXT MUSIC NOTE...
STARTOVER:
  READ X
  IF (X=$FF) THEN GOTO SKIP
  IF (X=0) THEN RESTORE:GOTO STARTOVER
  PSGNOTE 0,X
SKIP:
  REM ********************* 

  E(4)=TI:REM IMPORTANT, DO NOT REMOVE
  RETURN

EVENTo5:REM 1/16 SECOND STUFF
  REM *** DO STUFF ********
  LOCATE 9,X(5)
  PRINT "5";
  X(5) = X(5) + 1
  IF X(5) > CW THEN ZZ=1
  REM ********************* 

  E(5)=TI:REM IMPORTANT, DO NOT REMOVE
  RETURN

EVENTo6:REM 1/32 SECOND STUFF
  REM *** DO STUFF ********
  LOCATE 10,X(6)
  PRINT "6";
  X(6) = X(6) + 1
  IF X(6) > CW THEN ZZ=1

  REM **************** CHECK KEYBOARD
  GET A$
  A = ASC(A$)
  IF (A = 27) THEN GOTO TERMINATE
  REM ********************* 

  E(6)=TI:REM IMPORTANT, DO NOT REMOVE
  RETURN

EVENTo7:REM 1/64 SECOND STUFF
  REM *** DO STUFF ********
  LOCATE 11,X(7)
  PRINT "7";
  X(7) = X(7) + 1
  IF X(7) > CW THEN ZZ=1
  REM ********************* 

  E(7)=TI:REM IMPORTANT, DO NOT REMOVE
  RETURN

REM ******************
MUSIC:REM <OCTAVE>,<NOTE>
DATA $45
DATA $48
DATA $4C
DATA $4E
DATA $FF
DATA $55
DATA $58
DATA $5C
DATA $5E
DATA 00
REM ******************

TERMINATE:
  PSGINIT
  LOCATE 20,1
  END
